<template>
  <div class="table-content">
    <div class="header-content">
      <div
        v-for="(header) in headers"
        :key="header">
        {{ header }}
      </div>
    </div>
    <div class="empty-content" v-if="!users.length">
      No hay ningún usuario para mostrar
    </div>
    <div
      class="row-content"
      v-for="(user) in users"
        :class="{ 'selected': userSelected && userSelected.id === user.id }"
        :key="user.id"
        @click="selectUser(user)">
      <div>{{ user.gender }}</div>
      <div>{{ user.name }}</div>
      <div>{{ user.email }}</div>
      <div>{{ user.nationality }}</div>
      <div>{{ user.birthDate }}</div>
      <div>{{ user.registeredDate }}</div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.table-content {
  display: table;
  width: 100%;
  border-collapse: collapse;
}

.row-content, .header-content {
  display: table-row;
  cursor: pointer;
  div {
    display: table-cell;
    vertical-align: middle;
    padding: 5px;
    text-align: left;
  }
}

.row-content {
  &:nth-child(2n + 1) {
    background-color: #f1f1f1;
  }
  &:hover {
    background-color: #ffeeee;
  }
  &.selected {
    background-color: #ffcccc;
  }
}

.header-content {
  div {
    font-weight: bold;
    background: #666666;
    color: #ffffff;
  }
}
</style>

<script>
export default {
  name: 'UserList',

  data() {
    return {
      userSelected: null,
    };
  },

  props: {
    headers: {
      type: Array,
      default: () => [],
    },
    users: {
      type: Array,
      default: () => [],
    },
  },

  methods: {
    selectUser(user) {
      this.userSelected = this.userSelected && this.userSelected.id === user.id ? null : user;
      this.$emit('select-user', this.userSelected);
    },
  },
};
</script>
